<template>
    <v-select
        v-model="localValue"
        :error-messages="errors"
        :items="warehouse"
        item-text="name"
        item-value="id"
        :cache-items="true"
        :loading="loading"
        :placeholder="placeholder"
        :hide-details="hideDetails"
        :clearable="clearable"
        outlined
        :menu-props="{ bottom: true, offsetY: true }"
    >
        <template slot="selection" slot-scope="data">
            {{ data.item.name }}
        </template>
        <template slot="item" slot-scope="data">
            {{ data.item.name }}
        </template>
    </v-select>
</template>

<script>
    export default {
        name: "VWarehouseSelect",
        props: {
            value: {
                required: true,
                default: null
            },
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            clearable: {
                type: Boolean,
                default: false
            }
        },
        data: () => ({
            loading: true,
            warehouse: []
        }),
        computed: {
            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },
        mounted() {
            axios.get('api/warehouses')
                .then(({ data }) => {
                    this.loading = false;
                    this.warehouse = data.data;
                })
                .catch(error => {
                    this.loading = false;
                    console.error('Request failed. Returned status of', error.response.status);
                })
        }
    }
</script>

<style scoped>

</style>
